/* Automatically generated from ./jit-opcodes.ops - DO NOT EDIT */

/*
 * jit-opcode.c - Information about all of the JIT opcodes.
 *
 * Copyright (C) 2004  Southern Storm Software, Pty Ltd.
 *
 * This file is part of the libjit library.
 *
 * The libjit library is free software: you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * The libjit library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with the libjit library.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "jit-internal.h"
#include "jit-rules.h"

#if defined(JIT_BACKEND_INTERP)
	#define	NINT_ARG			JIT_OPCODE_NINT_ARG
	#define	NINT_ARG_TWO		JIT_OPCODE_NINT_ARG_TWO
	#define	INDIRECT_ARGS		JIT_OPCODE_CALL_INDIRECT_ARGS
#else
	#define	NINT_ARG			0
	#define	NINT_ARG_TWO		0
	#define	INDIRECT_ARGS		0
#endif

jit_opcode_info_t const jit_opcodes[JIT_OP_NUM_OPCODES] = {
	{"nop", 0},
	{"trunc_sbyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"trunc_ubyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"trunc_short", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"trunc_ushort", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"trunc_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"trunc_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"check_sbyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"check_ubyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"check_short", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"check_ushort", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"check_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"check_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"low_word", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG},
	{"expand_int", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_INT},
	{"expand_uint", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_INT},
	{"check_low_word", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG},
	{"check_signed_low_word", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG},
	{"check_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG},
	{"check_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG},
	{"float32_to_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"float32_to_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"float32_to_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT32},
	{"float32_to_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT32},
	{"check_float32_to_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"check_float32_to_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"check_float32_to_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT32},
	{"check_float32_to_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT32},
	{"int_to_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_INT},
	{"uint_to_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_INT},
	{"long_to_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_LONG},
	{"ulong_to_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_LONG},
	{"float32_to_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT32},
	{"float64_to_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"float64_to_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"float64_to_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT64},
	{"float64_to_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT64},
	{"check_float64_to_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"check_float64_to_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"check_float64_to_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT64},
	{"check_float64_to_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_FLOAT64},
	{"int_to_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_INT},
	{"uint_to_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_INT},
	{"long_to_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_LONG},
	{"ulong_to_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_LONG},
	{"float64_to_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT64},
	{"nfloat_to_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfloat_to_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfloat_to_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_NFLOAT},
	{"nfloat_to_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_NFLOAT},
	{"check_nfloat_to_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"check_nfloat_to_uint", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"check_nfloat_to_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_NFLOAT},
	{"check_nfloat_to_ulong", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_NFLOAT},
	{"int_to_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_INT},
	{"uint_to_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_INT},
	{"long_to_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_LONG},
	{"ulong_to_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_LONG},
	{"nfloat_to_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_NFLOAT},
	{"nfloat_to_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_NFLOAT},
	{"float32_to_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_FLOAT32},
	{"float64_to_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_FLOAT64},
	{"iadd", JIT_OPCODE_OPER_ADD | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"iadd_ovf", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"iadd_ovf_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"isub", JIT_OPCODE_OPER_SUB | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"isub_ovf", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"isub_ovf_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"imul", JIT_OPCODE_OPER_MUL | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"imul_ovf", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"imul_ovf_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"idiv", JIT_OPCODE_OPER_DIV | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"idiv_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"irem", JIT_OPCODE_OPER_REM | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"irem_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ineg", JIT_OPCODE_OPER_NEG | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"ladd", JIT_OPCODE_OPER_ADD | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"ladd_ovf", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"ladd_ovf_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lsub", JIT_OPCODE_OPER_SUB | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lsub_ovf", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lsub_ovf_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lmul", JIT_OPCODE_OPER_MUL | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lmul_ovf", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lmul_ovf_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"ldiv", JIT_OPCODE_OPER_DIV | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"ldiv_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lrem", JIT_OPCODE_OPER_REM | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lrem_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lneg", JIT_OPCODE_OPER_NEG | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG},
	{"fadd", JIT_OPCODE_OPER_ADD | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fsub", JIT_OPCODE_OPER_SUB | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fmul", JIT_OPCODE_OPER_MUL | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fdiv", JIT_OPCODE_OPER_DIV | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"frem", JIT_OPCODE_OPER_REM | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"frem_ieee", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fneg", JIT_OPCODE_OPER_NEG | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"dadd", JIT_OPCODE_OPER_ADD | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dsub", JIT_OPCODE_OPER_SUB | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dmul", JIT_OPCODE_OPER_MUL | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"ddiv", JIT_OPCODE_OPER_DIV | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"drem", JIT_OPCODE_OPER_REM | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"drem_ieee", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dneg", JIT_OPCODE_OPER_NEG | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"nfadd", JIT_OPCODE_OPER_ADD | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfsub", JIT_OPCODE_OPER_SUB | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfmul", JIT_OPCODE_OPER_MUL | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfdiv", JIT_OPCODE_OPER_DIV | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfrem", JIT_OPCODE_OPER_REM | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfrem_ieee", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfneg", JIT_OPCODE_OPER_NEG | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"iand", JIT_OPCODE_OPER_AND | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ior", JIT_OPCODE_OPER_OR | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ixor", JIT_OPCODE_OPER_XOR | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"inot", JIT_OPCODE_OPER_NOT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"ishl", JIT_OPCODE_OPER_SHL | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ishr", JIT_OPCODE_OPER_SHR | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ishr_un", JIT_OPCODE_OPER_SHR_UN | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"land", JIT_OPCODE_OPER_AND | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lor", JIT_OPCODE_OPER_OR | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lxor", JIT_OPCODE_OPER_XOR | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lnot", JIT_OPCODE_OPER_NOT | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG},
	{"lshl", JIT_OPCODE_OPER_SHL | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_INT},
	{"lshr", JIT_OPCODE_OPER_SHR | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_INT},
	{"lshr_un", JIT_OPCODE_OPER_SHR_UN | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_INT},
	{"br", JIT_OPCODE_IS_BRANCH},
	{"br_ifalse", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_INT},
	{"br_itrue", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_INT},
	{"br_ieq", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_EQ | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ine", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_NE | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ilt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ilt_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ile", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LE | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ile_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_igt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_igt_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ige", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GE | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_ige_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"br_lfalse", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_LONG},
	{"br_ltrue", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_LONG},
	{"br_leq", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_EQ | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lne", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_NE | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_llt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_llt_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lle", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LE | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lle_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lgt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lgt_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lge", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GE | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_lge_un", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"br_feq", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_EQ | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fne", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_NE | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_flt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fle", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LE | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fgt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fge", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GE | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_flt_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fle_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fgt_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_fge_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"br_deq", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_EQ | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dne", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_NE | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dlt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dle", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LE | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dgt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dge", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GE | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dlt_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dle_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dgt_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_dge_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"br_nfeq", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_EQ | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfne", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_NE | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nflt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfle", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_LE | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfgt", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfge", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_OPER_GE | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nflt_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfle_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfgt_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"br_nfge_inv", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"icmp", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"icmp_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"lcmp", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lcmp_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"fcmpl", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fcmpg", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"dcmpl", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dcmpg", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"nfcmpl", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfcmpg", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"ieq", JIT_OPCODE_OPER_EQ | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ine", JIT_OPCODE_OPER_NE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ilt", JIT_OPCODE_OPER_LT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ilt_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ile", JIT_OPCODE_OPER_LE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ile_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"igt", JIT_OPCODE_OPER_GT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"igt_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ige", JIT_OPCODE_OPER_GE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"ige_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"leq", JIT_OPCODE_OPER_EQ | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lne", JIT_OPCODE_OPER_NE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"llt", JIT_OPCODE_OPER_LT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"llt_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lle", JIT_OPCODE_OPER_LE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lle_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lgt", JIT_OPCODE_OPER_GT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lgt_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lge", JIT_OPCODE_OPER_GE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lge_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"feq", JIT_OPCODE_OPER_EQ | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fne", JIT_OPCODE_OPER_NE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"flt", JIT_OPCODE_OPER_LT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fle", JIT_OPCODE_OPER_LE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fgt", JIT_OPCODE_OPER_GT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fge", JIT_OPCODE_OPER_GE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"flt_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fle_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fgt_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fge_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"deq", JIT_OPCODE_OPER_EQ | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dne", JIT_OPCODE_OPER_NE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dlt", JIT_OPCODE_OPER_LT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dle", JIT_OPCODE_OPER_LE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dgt", JIT_OPCODE_OPER_GT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dge", JIT_OPCODE_OPER_GE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dlt_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dle_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dgt_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dge_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"nfeq", JIT_OPCODE_OPER_EQ | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfne", JIT_OPCODE_OPER_NE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nflt", JIT_OPCODE_OPER_LT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfle", JIT_OPCODE_OPER_LE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfgt", JIT_OPCODE_OPER_GT | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfge", JIT_OPCODE_OPER_GE | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nflt_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfle_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfgt_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfge_inv", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"is_fnan", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"is_finf", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"is_ffinite", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"is_dnan", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"is_dinf", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"is_dfinite", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"is_nfnan", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"is_nfinf", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"is_nffinite", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"facos", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fasin", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fatan", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fatan2", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"fceil", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fcos", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fcosh", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fexp", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"ffloor", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"flog", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"flog10", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fpow", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"frint", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fround", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fsin", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fsinh", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"fsqrt", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"ftan", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"ftanh", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"ftrunc", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"dacos", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dasin", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"datan", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"datan2", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"dceil", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dcos", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dcosh", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dexp", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dfloor", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dlog", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dlog10", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dpow", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"drint", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dround", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dsin", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dsinh", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dsqrt", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dtan", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dtanh", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"dtrunc", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"nfacos", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfasin", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfatan", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfatan2", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfceil", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfcos", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfcosh", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfexp", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nffloor", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nflog", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nflog10", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfpow", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"nfrint", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfround", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfsin", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfsinh", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nfsqrt", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nftan", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nftanh", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"nftrunc", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"iabs", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"labs", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG},
	{"fabs", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"dabs", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"nfabs", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"imin", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"imin_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"lmin", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lmin_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"fmin", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"dmin", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"nfmin", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"imax", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"imax_un", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"lmax", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"lmax_un", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_LONG},
	{"fmax", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_FLOAT32},
	{"dmax", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_FLOAT64},
	{"nfmax", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_NFLOAT},
	{"isign", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"lsign", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_LONG},
	{"fsign", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT32},
	{"dsign", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_FLOAT64},
	{"nfsign", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_NFLOAT},
	{"check_null", JIT_OPCODE_SRC1_PTR},
	{"call", JIT_OPCODE_IS_CALL},
	{"call_tail", JIT_OPCODE_IS_CALL},
	{"call_indirect", JIT_OPCODE_SRC1_PTR | INDIRECT_ARGS},
	{"call_indirect_tail", JIT_OPCODE_SRC1_PTR | INDIRECT_ARGS},
	{"call_vtable_ptr", JIT_OPCODE_SRC1_PTR},
	{"call_vtable_ptr_tail", JIT_OPCODE_SRC1_PTR},
	{"call_external", JIT_OPCODE_IS_CALL_EXTERNAL},
	{"call_external_tail", JIT_OPCODE_IS_CALL_EXTERNAL},
	{"return", 0},
	{"return_int", JIT_OPCODE_SRC1_INT},
	{"return_long", JIT_OPCODE_SRC1_LONG},
	{"return_float32", JIT_OPCODE_SRC1_FLOAT32},
	{"return_float64", JIT_OPCODE_SRC1_FLOAT64},
	{"return_nfloat", JIT_OPCODE_SRC1_NFLOAT},
	{"return_small_struct", JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_PTR | NINT_ARG},
	{"setup_for_nested", JIT_OPCODE_SRC1_INT},
	{"setup_for_sibling", JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"import", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_ANY | JIT_OPCODE_SRC2_INT},
	{"throw", JIT_OPCODE_SRC1_PTR},
	{"rethrow", JIT_OPCODE_SRC1_PTR},
	{"load_pc", JIT_OPCODE_DEST_PTR},
	{"load_exception_pc", JIT_OPCODE_DEST_PTR},
	{"enter_finally", 0},
	{"leave_finally", 0},
	{"call_finally", JIT_OPCODE_IS_BRANCH},
	{"enter_filter", JIT_OPCODE_DEST_ANY},
	{"leave_filter", JIT_OPCODE_SRC1_ANY},
	{"call_filter", JIT_OPCODE_IS_BRANCH | JIT_OPCODE_SRC1_ANY},
	{"call_filter_return", JIT_OPCODE_DEST_ANY},
	{"address_of_label", JIT_OPCODE_IS_ADDROF_LABEL | JIT_OPCODE_DEST_PTR},
	{"copy_load_sbyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"copy_load_ubyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"copy_load_short", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"copy_load_ushort", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"copy_int", JIT_OPCODE_OPER_COPY | JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"copy_long", JIT_OPCODE_OPER_COPY | JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_LONG},
	{"copy_float32", JIT_OPCODE_OPER_COPY | JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_FLOAT32},
	{"copy_float64", JIT_OPCODE_OPER_COPY | JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_FLOAT64},
	{"copy_nfloat", JIT_OPCODE_OPER_COPY | JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_NFLOAT},
	{"copy_struct", JIT_OPCODE_OPER_COPY | JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_PTR | NINT_ARG},
	{"copy_store_byte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"copy_store_short", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_INT},
	{"address_of", JIT_OPCODE_OPER_ADDRESS_OF | JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_ANY},
	{"incoming_reg", JIT_OPCODE_IS_REG},
	{"incoming_frame_posn", JIT_OPCODE_SRC1_ANY | JIT_OPCODE_SRC2_INT},
	{"outgoing_reg", JIT_OPCODE_IS_REG},
	{"outgoing_frame_posn", JIT_OPCODE_SRC1_ANY | JIT_OPCODE_SRC2_INT},
	{"return_reg", JIT_OPCODE_IS_REG},
	{"push_int", JIT_OPCODE_SRC1_INT},
	{"push_long", JIT_OPCODE_SRC1_LONG},
	{"push_float32", JIT_OPCODE_SRC1_FLOAT32},
	{"push_float64", JIT_OPCODE_SRC1_FLOAT64},
	{"push_nfloat", JIT_OPCODE_SRC1_NFLOAT},
	{"push_struct", JIT_OPCODE_SRC1_ANY | JIT_OPCODE_SRC2_PTR | NINT_ARG},
	{"pop_stack", JIT_OPCODE_SRC1_INT | NINT_ARG},
	{"flush_small_struct", JIT_OPCODE_SRC1_ANY | NINT_ARG},
	{"set_param_int", JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_PTR},
	{"set_param_long", JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_PTR},
	{"set_param_float32", JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_PTR},
	{"set_param_float64", JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_PTR},
	{"set_param_nfloat", JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_PTR},
	{"set_param_struct", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_PTR},
	{"push_return_area_ptr", 0},
	{"load_relative_sbyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_ubyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_short", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_ushort", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_relative_struct", JIT_OPCODE_DEST_ANY | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG_TWO},
	{"store_relative_byte", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_short", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_int", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_long", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_LONG | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_float32", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_FLOAT32 | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_float64", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_FLOAT64 | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_nfloat", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_NFLOAT | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"store_relative_struct", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_ANY | JIT_OPCODE_SRC2_INT | NINT_ARG_TWO},
	{"add_relative", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT | NINT_ARG},
	{"load_element_sbyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_ubyte", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_short", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_ushort", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_int", JIT_OPCODE_DEST_INT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_long", JIT_OPCODE_DEST_LONG | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_float32", JIT_OPCODE_DEST_FLOAT32 | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_float64", JIT_OPCODE_DEST_FLOAT64 | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"load_element_nfloat", JIT_OPCODE_DEST_NFLOAT | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT},
	{"store_element_byte", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"store_element_short", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"store_element_int", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_INT},
	{"store_element_long", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_LONG},
	{"store_element_float32", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_FLOAT32},
	{"store_element_float64", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_FLOAT64},
	{"store_element_nfloat", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_NFLOAT},
	{"memcpy", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_PTR},
	{"memmove", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_PTR},
	{"memset", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_INT | JIT_OPCODE_SRC2_PTR},
	{"alloca", JIT_OPCODE_DEST_PTR | JIT_OPCODE_SRC1_PTR},
	{"mark_offset", JIT_OPCODE_SRC1_INT},
	{"mark_breakpoint", JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_PTR},
	{"jump_table", JIT_OPCODE_IS_JUMP_TABLE | JIT_OPCODE_SRC1_PTR | JIT_OPCODE_SRC2_INT}
};

_jit_intrinsic_info_t const _jit_intrinsics[JIT_OP_NUM_OPCODES] = {
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_conv, 0},
	{0, JIT_SIG_i_ii, jit_int_add},
	{0, JIT_SIG_i_piii, jit_int_add_ovf},
	{0, JIT_SIG_i_pIII, jit_uint_add_ovf},
	{0, JIT_SIG_i_ii, jit_int_sub},
	{0, JIT_SIG_i_piii, jit_int_sub_ovf},
	{0, JIT_SIG_i_pIII, jit_uint_sub_ovf},
	{0, JIT_SIG_i_ii, jit_int_mul},
	{0, JIT_SIG_i_piii, jit_int_mul_ovf},
	{0, JIT_SIG_i_pIII, jit_uint_mul_ovf},
	{0, JIT_SIG_i_piii, jit_int_div},
	{0, JIT_SIG_i_pIII, jit_uint_div},
	{0, JIT_SIG_i_piii, jit_int_rem},
	{0, JIT_SIG_i_pIII, jit_uint_rem},
	{0, JIT_SIG_i_i, jit_int_neg},
	{0, JIT_SIG_l_ll, jit_long_add},
	{0, JIT_SIG_i_plll, jit_long_add_ovf},
	{0, JIT_SIG_i_pLLL, jit_ulong_add_ovf},
	{0, JIT_SIG_l_ll, jit_long_sub},
	{0, JIT_SIG_i_plll, jit_long_sub_ovf},
	{0, JIT_SIG_i_pLLL, jit_ulong_sub_ovf},
	{0, JIT_SIG_l_ll, jit_long_mul},
	{0, JIT_SIG_i_plll, jit_long_mul_ovf},
	{0, JIT_SIG_i_pLLL, jit_ulong_mul_ovf},
	{0, JIT_SIG_i_plll, jit_long_div},
	{0, JIT_SIG_i_pLLL, jit_ulong_div},
	{0, JIT_SIG_i_plll, jit_long_rem},
	{0, JIT_SIG_i_pLLL, jit_ulong_rem},
	{0, JIT_SIG_l_l, jit_long_neg},
	{0, JIT_SIG_f_ff, jit_float32_add},
	{0, JIT_SIG_f_ff, jit_float32_sub},
	{0, JIT_SIG_f_ff, jit_float32_mul},
	{0, JIT_SIG_f_ff, jit_float32_div},
	{0, JIT_SIG_f_ff, jit_float32_rem},
	{0, JIT_SIG_f_ff, jit_float32_ieee_rem},
	{0, JIT_SIG_f_f, jit_float32_neg},
	{0, JIT_SIG_d_dd, jit_float64_add},
	{0, JIT_SIG_d_dd, jit_float64_sub},
	{0, JIT_SIG_d_dd, jit_float64_mul},
	{0, JIT_SIG_d_dd, jit_float64_div},
	{0, JIT_SIG_d_dd, jit_float64_rem},
	{0, JIT_SIG_d_dd, jit_float64_ieee_rem},
	{0, JIT_SIG_d_d, jit_float64_neg},
	{0, JIT_SIG_D_DD, jit_nfloat_add},
	{0, JIT_SIG_D_DD, jit_nfloat_sub},
	{0, JIT_SIG_D_DD, jit_nfloat_mul},
	{0, JIT_SIG_D_DD, jit_nfloat_div},
	{0, JIT_SIG_D_DD, jit_nfloat_rem},
	{0, JIT_SIG_D_DD, jit_nfloat_ieee_rem},
	{0, JIT_SIG_D_D, jit_nfloat_neg},
	{0, JIT_SIG_i_ii, jit_int_and},
	{0, JIT_SIG_i_ii, jit_int_or},
	{0, JIT_SIG_i_ii, jit_int_xor},
	{0, JIT_SIG_i_i, jit_int_not},
	{0, JIT_SIG_i_iI, jit_int_shl},
	{0, JIT_SIG_i_iI, jit_int_shr},
	{0, JIT_SIG_i_iI, jit_uint_shr},
	{0, JIT_SIG_l_ll, jit_long_and},
	{0, JIT_SIG_l_ll, jit_long_or},
	{0, JIT_SIG_l_ll, jit_long_xor},
	{0, JIT_SIG_l_l, jit_long_not},
	{0, JIT_SIG_l_lI, jit_long_shl},
	{0, JIT_SIG_l_lI, jit_long_shr},
	{0, JIT_SIG_L_LI, jit_ulong_shr},
	{0, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH_UNARY | _JIT_INTRINSIC_FLAG_IFALSE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH_UNARY | _JIT_INTRINSIC_FLAG_ITRUE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_IEQ, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_INE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_ILT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_ILT_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_ILE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_ILE_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_IGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_IGT_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_IGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_IGE_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH_UNARY | _JIT_INTRINSIC_FLAG_LFALSE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH_UNARY | _JIT_INTRINSIC_FLAG_LTRUE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LEQ, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LNE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LLT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LLT_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LLE_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LGT_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_LGE_UN, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FEQ, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FNE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FLT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FLT_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FLE_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FGT_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_FGE_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DEQ, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DNE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DLT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DLT_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DLE_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DGT_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_DGE_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFEQ, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFNE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFLT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFLT_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFLE_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFGT_INV, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_BRANCH | JIT_OP_NFGE_INV, JIT_SIG_NONE, 0},
	{0, JIT_SIG_i_ii, jit_int_cmp},
	{0, JIT_SIG_i_II, jit_uint_cmp},
	{0, JIT_SIG_i_ll, jit_long_cmp},
	{0, JIT_SIG_i_LL, jit_ulong_cmp},
	{0, JIT_SIG_i_ff, jit_float32_cmpl},
	{0, JIT_SIG_i_ff, jit_float32_cmpg},
	{0, JIT_SIG_i_dd, jit_float64_cmpl},
	{0, JIT_SIG_i_dd, jit_float64_cmpg},
	{0, JIT_SIG_i_DD, jit_nfloat_cmpl},
	{0, JIT_SIG_i_DD, jit_nfloat_cmpg},
	{0, JIT_SIG_i_ii, jit_int_eq},
	{0, JIT_SIG_i_ii, jit_int_ne},
	{0, JIT_SIG_i_ii, jit_int_lt},
	{0, JIT_SIG_i_II, jit_uint_lt},
	{0, JIT_SIG_i_ii, jit_int_le},
	{0, JIT_SIG_i_II, jit_uint_le},
	{0, JIT_SIG_i_ii, jit_int_gt},
	{0, JIT_SIG_i_II, jit_uint_gt},
	{0, JIT_SIG_i_ii, jit_int_ge},
	{0, JIT_SIG_i_II, jit_uint_ge},
	{0, JIT_SIG_i_ll, jit_long_eq},
	{0, JIT_SIG_i_ll, jit_long_ne},
	{0, JIT_SIG_i_ll, jit_long_lt},
	{0, JIT_SIG_i_LL, jit_ulong_lt},
	{0, JIT_SIG_i_ll, jit_long_le},
	{0, JIT_SIG_i_LL, jit_ulong_le},
	{0, JIT_SIG_i_ll, jit_long_gt},
	{0, JIT_SIG_i_LL, jit_ulong_gt},
	{0, JIT_SIG_i_ll, jit_long_ge},
	{0, JIT_SIG_i_LL, jit_ulong_ge},
	{0, JIT_SIG_i_ff, jit_float32_eq},
	{0, JIT_SIG_i_ff, jit_float32_ne},
	{0, JIT_SIG_i_ff, jit_float32_lt},
	{0, JIT_SIG_i_ff, jit_float32_le},
	{0, JIT_SIG_i_ff, jit_float32_gt},
	{0, JIT_SIG_i_ff, jit_float32_ge},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_FGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_FGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_FLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_FLT, JIT_SIG_NONE, 0},
	{0, JIT_SIG_i_dd, jit_float64_eq},
	{0, JIT_SIG_i_dd, jit_float64_ne},
	{0, JIT_SIG_i_dd, jit_float64_lt},
	{0, JIT_SIG_i_dd, jit_float64_le},
	{0, JIT_SIG_i_dd, jit_float64_gt},
	{0, JIT_SIG_i_dd, jit_float64_ge},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_DGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_DGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_DLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_DLT, JIT_SIG_NONE, 0},
	{0, JIT_SIG_i_DD, jit_nfloat_eq},
	{0, JIT_SIG_i_DD, jit_nfloat_ne},
	{0, JIT_SIG_i_DD, jit_nfloat_lt},
	{0, JIT_SIG_i_DD, jit_nfloat_le},
	{0, JIT_SIG_i_DD, jit_nfloat_gt},
	{0, JIT_SIG_i_DD, jit_nfloat_ge},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_NFGE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_NFGT, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_NFLE, JIT_SIG_NONE, 0},
	{_JIT_INTRINSIC_FLAG_NOT | JIT_OP_NFLT, JIT_SIG_NONE, 0},
	{0, JIT_SIG_i_f, jit_float32_is_nan},
	{0, JIT_SIG_i_f, jit_float32_is_inf},
	{0, JIT_SIG_i_f, jit_float32_is_finite},
	{0, JIT_SIG_i_d, jit_float64_is_nan},
	{0, JIT_SIG_i_d, jit_float64_is_inf},
	{0, JIT_SIG_i_d, jit_float64_is_finite},
	{0, JIT_SIG_i_D, jit_nfloat_is_nan},
	{0, JIT_SIG_i_D, jit_nfloat_is_inf},
	{0, JIT_SIG_i_D, jit_nfloat_is_finite},
	{0, JIT_SIG_f_f, jit_float32_acos},
	{0, JIT_SIG_f_f, jit_float32_asin},
	{0, JIT_SIG_f_f, jit_float32_atan},
	{0, JIT_SIG_f_ff, jit_float32_atan2},
	{0, JIT_SIG_f_f, jit_float32_ceil},
	{0, JIT_SIG_f_f, jit_float32_cos},
	{0, JIT_SIG_f_f, jit_float32_cosh},
	{0, JIT_SIG_f_f, jit_float32_exp},
	{0, JIT_SIG_f_f, jit_float32_floor},
	{0, JIT_SIG_f_f, jit_float32_log},
	{0, JIT_SIG_f_f, jit_float32_log10},
	{0, JIT_SIG_f_ff, jit_float32_pow},
	{0, JIT_SIG_f_f, jit_float32_rint},
	{0, JIT_SIG_f_f, jit_float32_round},
	{0, JIT_SIG_f_f, jit_float32_sin},
	{0, JIT_SIG_f_f, jit_float32_sinh},
	{0, JIT_SIG_f_f, jit_float32_sqrt},
	{0, JIT_SIG_f_f, jit_float32_tan},
	{0, JIT_SIG_f_f, jit_float32_tanh},
	{0, JIT_SIG_f_f, jit_float32_trunc},
	{0, JIT_SIG_d_d, jit_float64_acos},
	{0, JIT_SIG_d_d, jit_float64_asin},
	{0, JIT_SIG_d_d, jit_float64_atan},
	{0, JIT_SIG_d_dd, jit_float64_atan2},
	{0, JIT_SIG_d_d, jit_float64_ceil},
	{0, JIT_SIG_d_d, jit_float64_cos},
	{0, JIT_SIG_d_d, jit_float64_cosh},
	{0, JIT_SIG_d_d, jit_float64_exp},
	{0, JIT_SIG_d_d, jit_float64_floor},
	{0, JIT_SIG_d_d, jit_float64_log},
	{0, JIT_SIG_d_d, jit_float64_log10},
	{0, JIT_SIG_d_dd, jit_float64_pow},
	{0, JIT_SIG_d_d, jit_float64_rint},
	{0, JIT_SIG_d_d, jit_float64_round},
	{0, JIT_SIG_d_d, jit_float64_sin},
	{0, JIT_SIG_d_d, jit_float64_sinh},
	{0, JIT_SIG_d_d, jit_float64_sqrt},
	{0, JIT_SIG_d_d, jit_float64_tan},
	{0, JIT_SIG_d_d, jit_float64_tanh},
	{0, JIT_SIG_d_d, jit_float64_trunc},
	{0, JIT_SIG_D_D, jit_nfloat_acos},
	{0, JIT_SIG_D_D, jit_nfloat_asin},
	{0, JIT_SIG_D_D, jit_nfloat_atan},
	{0, JIT_SIG_D_DD, jit_nfloat_atan2},
	{0, JIT_SIG_D_D, jit_nfloat_ceil},
	{0, JIT_SIG_D_D, jit_nfloat_cos},
	{0, JIT_SIG_D_D, jit_nfloat_cosh},
	{0, JIT_SIG_D_D, jit_nfloat_exp},
	{0, JIT_SIG_D_D, jit_nfloat_floor},
	{0, JIT_SIG_D_D, jit_nfloat_log},
	{0, JIT_SIG_D_D, jit_nfloat_log10},
	{0, JIT_SIG_D_DD, jit_nfloat_pow},
	{0, JIT_SIG_D_D, jit_nfloat_rint},
	{0, JIT_SIG_D_D, jit_nfloat_round},
	{0, JIT_SIG_D_D, jit_nfloat_sin},
	{0, JIT_SIG_D_D, jit_nfloat_sinh},
	{0, JIT_SIG_D_D, jit_nfloat_sqrt},
	{0, JIT_SIG_D_D, jit_nfloat_tan},
	{0, JIT_SIG_D_D, jit_nfloat_tanh},
	{0, JIT_SIG_D_D, jit_nfloat_trunc},
	{0, JIT_SIG_i_i, jit_int_abs},
	{0, JIT_SIG_l_l, jit_long_abs},
	{0, JIT_SIG_f_f, jit_float32_abs},
	{0, JIT_SIG_d_d, jit_float64_abs},
	{0, JIT_SIG_D_D, jit_nfloat_abs},
	{0, JIT_SIG_i_ii, jit_int_min},
	{0, JIT_SIG_I_II, jit_uint_min},
	{0, JIT_SIG_l_ll, jit_long_min},
	{0, JIT_SIG_L_LL, jit_ulong_min},
	{0, JIT_SIG_f_ff, jit_float32_min},
	{0, JIT_SIG_d_dd, jit_float64_min},
	{0, JIT_SIG_D_DD, jit_nfloat_min},
	{0, JIT_SIG_i_ii, jit_int_max},
	{0, JIT_SIG_I_II, jit_uint_max},
	{0, JIT_SIG_l_ll, jit_long_max},
	{0, JIT_SIG_L_LL, jit_ulong_max},
	{0, JIT_SIG_f_ff, jit_float32_max},
	{0, JIT_SIG_d_dd, jit_float64_max},
	{0, JIT_SIG_D_DD, jit_nfloat_max},
	{0, JIT_SIG_i_i, jit_int_sign},
	{0, JIT_SIG_i_l, jit_long_sign},
	{0, JIT_SIG_i_f, jit_float32_sign},
	{0, JIT_SIG_i_d, jit_float64_sign},
	{0, JIT_SIG_i_D, jit_nfloat_sign},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0},
	{0, JIT_SIG_NONE, 0}
};
